//  IBM_PROLOG_BEGIN_TAG
//  This is an automatically generated prolog.
//
//  $Source: src/include/usr/hwpf/fapi/fapiReturnCodes.H $
//
//  IBM CONFIDENTIAL
//
//  COPYRIGHT International Business Machines Corp. 2011
//
//  p1
//
//  Object Code Only (OCO) source materials
//  Licensed Internal Code Source Materials
//  IBM HostBoot Licensed Internal Code
//
//  The source code for this program is not published or other-
//  wise divested of its trade secrets, irrespective of what has
//  been deposited with the U.S. Copyright Office.
//
//  Origin: 30
//
//  IBM_PROLOG_END
/**
 *  @file fapiReturnCodes.H
 *
 *  @brief Defines the returns codes generated by HWPF code.
 */

/*
 * Change Log ******************************************************************
 * Flag     Defect/Feature  User        Date        Description
 * ------   --------------  ----------  ----------- ----------------------------
 *                          mjjones     04/13/2011  Created.
 *                          mjjones     06/07/2011  Add FAPI_RC_NOT_IMPLEMENTED
 *                          mjjones     06/30/2011  Add FAPI_RC_ATTR_UNIT_TEST_FAIL
 *                          mjjones     08/10/2011  Add FAPI_RC_FFDC_HWP_NOT_FOUND
 *                          mjjones     09/23/2011  Remove FAPI_RC_FFDC_HWP_NOT_FOUND
 *                          mjjones     10/07/2011  Add FAPI_RC_INVALID_ATTR_GET
 *                          mjjones     10/28/2011  Trim FAPI/PLAT errors
 *                          mjjones     11/10/2011  Use ecmdDataBufferBase
 *                          mjjones     01/13/2012  Name enumeration
 */

#ifndef FAPIRETURNCODES_H_
#define FAPIRETURNCODES_H_

#include <ecmdDataBufferBase.H>

namespace fapi
{

/**
 * @brief Enumeration of return codes
 *
 * @note HWP return codes are in the HwpReturnCode enumeration in the
 *       generated fapiHwpReturnCodes.H file
 */
enum ReturnCodes
{
    FAPI_RC_SUCCESS = 0,

    // Flag bits indicating which code generated the error If no flag set then
    // it is generated by HWP
    FAPI_RC_FAPI_MASK = 0x04000000, // FAPI generated error
    FAPI_RC_PLAT_MASK = 0x02000000, // PLAT generated error
    FAPI_RC_ECMD_MASK = ECMD_ERR_ECMD, // ECMD generated error (0x01000000)

    // FAPI generated return codes
    FAPI_RC_INVALID_ATTR_GET = FAPI_RC_FAPI_MASK | 0x01,

    // PLAT generated return codes
    FAPI_RC_PLAT_ERR_SEE_DATA = FAPI_RC_PLAT_MASK | 0x01,
};

}

#endif // FAPIRETURNCODES_H_
